#include <amxmodx>
#include <amxmisc>
#include <colorchat>

new g_mapname[32]
new g_file_savenote[256]
new g_vote_verygood, g_vote_good, g_vote_bad, g_vote_verybad, g_vote_none

new cvar_start, cvar_delay, cvar_dateformat

new const notemap_start_sound[] = {"buttons/blip2.wav"}

public plugin_init()
{
	register_plugin("Notemap", "1.0", "Daminou")
	
	cvar_start = register_cvar("amx_notemap_start", "30.0")
	cvar_delay = register_cvar("amx_notemap_delay", "15.0")
	cvar_dateformat = register_cvar("amx_notemap_format", "en")
	
	get_mapname(g_mapname, 31)
	
	new filepath[256]
	get_datadir(filepath, 255)
	
	format(g_file_savenote, 255, "%s/notemap/%s.ini", filepath, g_mapname)
	
	set_task(get_pcvar_float(cvar_start), "start_notemap", _, _, _, "d")
	
	register_dictionary("notemap.txt")
	register_dictionary_colored("notemap.txt")
}

public plugin_precache()
{
	precache_sound(notemap_start_sound)
}

public start_notemap()
{
	new g_menu_notemap
	new menuText[32]
	
	new players[32], playerscount
	get_players(players, playerscount, "ch")
	for(new i; i < playerscount; i++)
	{
		new id = players[i]
		formatex(menuText, charsmax(menuText), "\r[Notemap]\y %s", g_mapname)
		g_menu_notemap = menu_create(menuText, "menu_notemap")
		formatex(menuText, charsmax(menuText), "\w%L", LANG_PLAYER, "NOTEMAP_VERYGOOD")
		menu_additem(g_menu_notemap, menuText, "1")
		formatex(menuText, charsmax(menuText), "\w%L", LANG_PLAYER, "NOTEMAP_GOOD")
		menu_additem(g_menu_notemap, menuText, "2")
		formatex(menuText, charsmax(menuText), "\w%L", LANG_PLAYER, "NOTEMAP_BAD")
		menu_additem(g_menu_notemap, menuText, "3")
		formatex(menuText, charsmax(menuText), "\w%L", LANG_PLAYER, "NOTEMAP_VERYBAD")
		menu_additem(g_menu_notemap, menuText, "4")
		formatex(menuText, charsmax(menuText), "\w%L", LANG_PLAYER, "NOTEMAP_EXIT")
		menu_setprop(g_menu_notemap, MPROP_EXITNAME, menuText)
		menu_setprop(g_menu_notemap, MPROP_EXIT, MEXIT_ALL)
		menu_display(id, g_menu_notemap)
		
		client_print_color(id, DontChange, "^4[Notemap]^1 %L", LANG_PLAYER, "NOTEMAP_DISPLAY", get_pcvar_float(cvar_delay))
	}
	client_cmd(0, "spk %s", notemap_start_sound)
	set_task(get_pcvar_float(cvar_delay), "end_notemap")
	return PLUGIN_HANDLED
}

public end_notemap()
{
	new players[32], playerscount
	get_players(players, playerscount, "ch")
	for(new i; i < playerscount; i++)
	{
		new id = players[i]
		menu_cancel(id)
	}
	new file_savenote = fopen(g_file_savenote, "at")
	if(!file_savenote)
	{
		client_print_color(0, DontChange, "^4[Notemap]^1 %L", LANG_SERVER, "NOTEMAP_ERROR")
		return PLUGIN_HANDLED
	}
	new year, month, day
	date(year, month, day)
	new date_format[32]
	get_pcvar_string(cvar_dateformat, date_format, charsmax(date_format))
	if(equal(date_format, "fr"))
	{
		fprintf(file_savenote, "[%d/%d/%d] ", day, month, year)
	}
	else
	{
		fprintf(file_savenote, "[%d/%d/%d] ", year, month, day)
	}
	fprintf(file_savenote, "%L: %d - %L: %d - %L: %d - %L: %d - %L: %d^n", LANG_SERVER, "NOTEMAP_VERYGOOD", g_vote_verygood, LANG_SERVER, "NOTEMAP_GOOD", g_vote_good, LANG_SERVER, "NOTEMAP_BAD", g_vote_bad, LANG_SERVER, "NOTEMAP_VERYBAD", g_vote_verybad, LANG_SERVER, "NOTEMAP_NONE", g_vote_none)
	fclose(file_savenote)
	client_print_color(0, DontChange, "^4[Notemap]^1 %L", LANG_SERVER, "NOTEMAP_SAVE")
	return PLUGIN_HANDLED
}

public menu_notemap(id, menu, item)
{
	new name[32]
	get_user_name(id, name, charsmax(name))
	if (item == MENU_EXIT)
	{
		client_print_color(0, DontChange, "^4[Notemap]^3 %s^1 %L:^4 %L", name, LANG_SERVER, "NOTEMAP_NOTE", LANG_SERVER, "NOTEMAP_NONE")
		g_vote_none++
		return PLUGIN_HANDLED
	}
	switch(item)
	{
		case 0:
		{
			client_print_color(0, DontChange, "^4[Notemap]^3 %s^1 %L:^4 %L", name, LANG_SERVER, "NOTEMAP_NOTE", LANG_SERVER, "NOTEMAP_VERYGOOD")
			g_vote_verygood++
		}
		case 1:
		{
			client_print_color(0, DontChange, "^4[Notemap]^3 %s^1 %L:^4 %L", name, LANG_SERVER, "NOTEMAP_NOTE", LANG_SERVER, "NOTEMAP_GOOD")
			g_vote_good++
		}
		case 2:
		{
			client_print_color(0, DontChange, "^4[Notemap]^3 %s^1 %L:^4 %L", name, LANG_SERVER, "NOTEMAP_NOTE", LANG_SERVER, "NOTEMAP_BAD")
			g_vote_bad++
		}
		case 3:
		{
			client_print_color(0, DontChange, "^4[Notemap]^3 %s^1 %L:^4 %L", name, LANG_SERVER, "NOTEMAP_NOTE", LANG_SERVER, "NOTEMAP_VERYBAD")
			g_vote_verybad++
		}
	}
	return PLUGIN_HANDLED
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1036\\ f0\\ fs16 \n\\ par }
*/
